@echo off
assets2banks assets --compile

sdcc -c -mz80 main.c
@if %errorlevel% NEQ 0 goto :EOF

sdcc -o phantasy_star_ii.ihx -mz80 --data-loc 0xC000 -Wl-b_BANK2=0x8000 --no-std-crt0 crt0_sms.rel main.rel bank2.rel SMSlib.lib .\lib\PSGLib.rel
ihx2sms phantasy_star_ii.ihx ryu_test.sms

echo clean up files
del *.lst
del *.sym
del *.lk
del *.map
del *.noi
del *.ihx

java -jar .\Emulicious\Emulicious.jar ryu_test.sms