#include "lib\SMSlib.h"
#include <stdbool.h>
#include "bank2.h"

// Header
SMS_EMBED_SEGA_ROM_HEADER(9999, 0);
SMS_EMBED_SDSC_HEADER(1, 0, 2022, 12, 7, "Test", "Test", "Test");

void LoadSprites() {
	SMS_initSprites();
	// Turtle 1
	SMS_addSprite(0, 0, 0);
	SMS_addSprite(8, 0, 2);
	SMS_addSprite(16, 0, 4);
	SMS_addSprite(0, 16, 6);
	SMS_addSprite(8, 16, 8);
	SMS_addSprite(16, 16, 10);
	SMS_addSprite(0, 32, 12);
	SMS_addSprite(8, 32, 14);
	SMS_addSprite(16, 32, 16);
	// Turtle 2
	SMS_addSprite(0, 0, 0);
	SMS_addSprite(8, 0, 2);
	SMS_addSprite(16, 0, 4);
	SMS_addSprite(0, 16, 6);
	SMS_addSprite(8, 16, 8);
	SMS_addSprite(16, 16, 10);
	SMS_addSprite(0, 32, 12);
	SMS_addSprite(8, 32, 14);
	SMS_addSprite(16, 32, 16);
	// Turtle 3
	SMS_addSprite(0, 0, 0);
	SMS_addSprite(8, 0, 2);
	SMS_addSprite(16, 0, 4);
	SMS_addSprite(0, 16, 6);
	SMS_addSprite(8, 16, 8);
	SMS_addSprite(16, 16, 10);
	SMS_addSprite(0, 32, 12);
	SMS_addSprite(8, 32, 14);
	SMS_addSprite(16, 32, 16);
	// Turtle 4
	SMS_addSprite(0, 0, 0);
	SMS_addSprite(8, 0, 2);
	SMS_addSprite(16, 0, 4);
	SMS_addSprite(0, 16, 6);
	SMS_addSprite(8, 16, 8);
	SMS_addSprite(16, 16, 10);
	SMS_addSprite(0, 32, 12);
	SMS_addSprite(8, 32, 14);
	SMS_addSprite(16, 32, 16);
	// Turtle 5
	SMS_addSprite(0, 0, 0);
	SMS_addSprite(8, 0, 2);
	SMS_addSprite(16, 0, 4);
	SMS_addSprite(0, 16, 6);
	SMS_addSprite(8, 16, 8);
	SMS_addSprite(16, 16, 10);
	SMS_addSprite(0, 32, 12);
	SMS_addSprite(8, 32, 14);
	SMS_addSprite(16, 32, 16);
	// Turtle 6
	SMS_addSprite(0, 0, 0);
	SMS_addSprite(8, 0, 2);
	SMS_addSprite(16, 0, 4);
	SMS_addSprite(0, 16, 6);
	SMS_addSprite(8, 16, 8);
	SMS_addSprite(16, 16, 10);
	SMS_addSprite(0, 32, 12);
	SMS_addSprite(8, 32, 14);
	SMS_addSprite(16, 32, 16);
	// Turtle 7
	SMS_addSprite(0, 0, 0);
	SMS_addSprite(8, 0, 2);
	SMS_addSprite(16, 0, 4);
	SMS_addSprite(0, 16, 6);
	SMS_addSprite(8, 16, 8);
	SMS_addSprite(16, 16, 10);
	SMS_addSprite(0, 32, 12);
	SMS_addSprite(8, 32, 14);
	SMS_addSprite(16, 32, 16);
	SMS_copySpritestoSAT();
}

void UpdateSprites() {
	UNSAFE_SMS_copySpritestoSAT();
	// Turtle 1
	SMS_updateSpritePosition(0, 0, 0);
	SMS_updateSpritePosition(1, 8, 0);
	SMS_updateSpritePosition(2, 16, 0);
	SMS_updateSpritePosition(3, 0, 16);
	SMS_updateSpritePosition(4, 8, 16);
	SMS_updateSpritePosition(5, 16, 16);
	SMS_updateSpritePosition(6, 0, 32);
	SMS_updateSpritePosition(7, 8, 32);
	SMS_updateSpritePosition(8, 16, 32);

	SMS_updateSpriteImage(0, 0);
	SMS_updateSpriteImage(1, 2);
	SMS_updateSpriteImage(2, 4);
	SMS_updateSpriteImage(3, 6);
	SMS_updateSpriteImage(4, 8);
	SMS_updateSpriteImage(5, 10);
	SMS_updateSpriteImage(6, 12);
	SMS_updateSpriteImage(7, 14);
	SMS_updateSpriteImage(8, 16);

	// Turtle 2
	SMS_updateSpritePosition(9, 0, 48);
	SMS_updateSpritePosition(10, 8, 48);
	SMS_updateSpritePosition(11, 16, 48);
	SMS_updateSpritePosition(12, 0, 64);
	SMS_updateSpritePosition(13, 8, 64);
	SMS_updateSpritePosition(14, 16, 64);
	SMS_updateSpritePosition(15, 0, 80);
	SMS_updateSpritePosition(16, 8, 80);
	SMS_updateSpritePosition(17, 16, 80);

	SMS_updateSpriteImage(9, 0);
	SMS_updateSpriteImage(10, 2);
	SMS_updateSpriteImage(11, 4);
	SMS_updateSpriteImage(12, 6);
	SMS_updateSpriteImage(13, 8);
	SMS_updateSpriteImage(14, 10);
	SMS_updateSpriteImage(15, 12);
	SMS_updateSpriteImage(16, 14);
	SMS_updateSpriteImage(17, 16);

	// Turtle 3
	SMS_updateSpritePosition(18, 0, 96);
	SMS_updateSpritePosition(19, 8, 96);
	SMS_updateSpritePosition(20, 16, 96);
	SMS_updateSpritePosition(21, 0, 112);
	SMS_updateSpritePosition(22, 8, 112);
	SMS_updateSpritePosition(23, 16, 112);
	SMS_updateSpritePosition(24, 0, 128);
	SMS_updateSpritePosition(25, 8, 128);
	SMS_updateSpritePosition(26, 16, 128);

	SMS_updateSpriteImage(18, 0);
	SMS_updateSpriteImage(19, 2);
	SMS_updateSpriteImage(20, 4);
	SMS_updateSpriteImage(21, 6);
	SMS_updateSpriteImage(22, 8);
	SMS_updateSpriteImage(23, 10);
	SMS_updateSpriteImage(24, 12);
	SMS_updateSpriteImage(25, 14);
	SMS_updateSpriteImage(26, 16);

	// Turtle 4
	SMS_updateSpritePosition(27, 0, 144);
	SMS_updateSpritePosition(28, 8, 144);
	SMS_updateSpritePosition(29, 16, 144);
	SMS_updateSpritePosition(30, 0, 160);
	SMS_updateSpritePosition(31, 8, 160);
	SMS_updateSpritePosition(32, 16, 160);
	SMS_updateSpritePosition(33, 0, 176);
	SMS_updateSpritePosition(34, 8, 176);
	SMS_updateSpritePosition(35, 16, 176);

	SMS_updateSpriteImage(27, 0);
	SMS_updateSpriteImage(28, 2);
	SMS_updateSpriteImage(29, 4);
	SMS_updateSpriteImage(30, 6);
	SMS_updateSpriteImage(31, 8);
	SMS_updateSpriteImage(32, 10);
	SMS_updateSpriteImage(33, 12);
	SMS_updateSpriteImage(34, 14);
	SMS_updateSpriteImage(35, 16);

	// Turtle 5
	SMS_updateSpritePosition(36, 32, 0);
	SMS_updateSpritePosition(37, 40, 0);
	SMS_updateSpritePosition(38, 48, 0);
	SMS_updateSpritePosition(39, 32, 16);
	SMS_updateSpritePosition(40, 40, 16);
	SMS_updateSpritePosition(41, 48, 16);
	SMS_updateSpritePosition(42, 32, 32);
	SMS_updateSpritePosition(43, 40, 32);
	SMS_updateSpritePosition(44, 48, 32);

	SMS_updateSpriteImage(36, 0);
	SMS_updateSpriteImage(37, 2);
	SMS_updateSpriteImage(38, 4);
	SMS_updateSpriteImage(39, 6);
	SMS_updateSpriteImage(40, 8);
	SMS_updateSpriteImage(41, 10);
	SMS_updateSpriteImage(42, 12);
	SMS_updateSpriteImage(43, 14);
	SMS_updateSpriteImage(44, 16);

	// Turtle 6
	SMS_updateSpritePosition(45, 32, 48);
	SMS_updateSpritePosition(46, 40, 48);
	SMS_updateSpritePosition(47, 48, 48);
	SMS_updateSpritePosition(48, 32, 64);
	SMS_updateSpritePosition(49, 40, 64);
	SMS_updateSpritePosition(50, 48, 64);
	SMS_updateSpritePosition(51, 32, 80);
	SMS_updateSpritePosition(52, 40, 80);
	SMS_updateSpritePosition(53, 48, 80);

	SMS_updateSpriteImage(45, 0);
	SMS_updateSpriteImage(46, 2);
	SMS_updateSpriteImage(47, 4);
	SMS_updateSpriteImage(48, 6);
	SMS_updateSpriteImage(49, 8);
	SMS_updateSpriteImage(50, 10);
	SMS_updateSpriteImage(51, 12);
	SMS_updateSpriteImage(52, 14);
	SMS_updateSpriteImage(53, 16);

	// Turtle 7
	SMS_updateSpritePosition(54, 32, 96);
	SMS_updateSpritePosition(55, 40, 96);
	SMS_updateSpritePosition(56, 48, 96);
	SMS_updateSpritePosition(57, 32, 112);
	SMS_updateSpritePosition(58, 40, 112);
	SMS_updateSpritePosition(59, 48, 112);
	SMS_updateSpritePosition(60, 32, 128);
	SMS_updateSpritePosition(61, 40, 128);
	SMS_updateSpritePosition(62, 48, 128);

	SMS_updateSpriteImage(54, 0);
	SMS_updateSpriteImage(55, 2);
	SMS_updateSpriteImage(56, 4);
	SMS_updateSpriteImage(57, 6);
	SMS_updateSpriteImage(58, 8);
	SMS_updateSpriteImage(59, 10);
	SMS_updateSpriteImage(60, 12);
	SMS_updateSpriteImage(61, 14);
	SMS_updateSpriteImage(62, 16);
}

void AddSprites() {
	UNSAFE_SMS_copySpritestoSAT();
	SMS_initSprites();
	// Turtle 1
	SMS_addSprite(0, 0, 0);
	SMS_addSprite(8, 0, 2);
	SMS_addSprite(16, 0, 4);
	SMS_addSprite(0, 16, 6);
	SMS_addSprite(8, 16, 8);
	SMS_addSprite(16, 16, 10);
	SMS_addSprite(0, 32, 12);
	SMS_addSprite(8, 32, 14);
	SMS_addSprite(16, 32, 16);

	// Turtle 2
	SMS_addSprite(0, 48, 0);
	SMS_addSprite(8, 48, 2);
	SMS_addSprite(16, 48, 4);
	SMS_addSprite(0, 64, 6);
	SMS_addSprite(8, 64, 8);
	SMS_addSprite(16, 64, 10);
	SMS_addSprite(0, 80, 12);
	SMS_addSprite(8, 80, 14);
	SMS_addSprite(16, 80, 16);

	// Turtle 3
	SMS_addSprite(0, 96, 0);
	SMS_addSprite(8, 96, 2);
	SMS_addSprite(16, 96, 4);
	SMS_addSprite(0, 112, 6);
	SMS_addSprite(8, 112, 8);
	SMS_addSprite(16, 112, 10);
	SMS_addSprite(0, 128, 12);
	SMS_addSprite(8, 128, 14);
	SMS_addSprite(16, 128, 16);

	// Turtle 4
	SMS_addSprite(0, 144, 0);
	SMS_addSprite(8, 144, 2);
	SMS_addSprite(16, 144, 4);
	SMS_addSprite(0, 160, 6);
	SMS_addSprite(8, 160, 8);
	SMS_addSprite(16, 160, 10);
	SMS_addSprite(0, 176, 12);
	SMS_addSprite(8, 176, 14);
	SMS_addSprite(16, 176, 16);

	// Turtle 5
	SMS_addSprite(32, 0, 0);
	SMS_addSprite(40, 0, 2);
	SMS_addSprite(48, 0, 4);
	SMS_addSprite(32, 16, 6);
	SMS_addSprite(40, 16, 8);
	SMS_addSprite(48, 16, 10);
	SMS_addSprite(32, 32, 12);
	SMS_addSprite(40, 32, 14);
	SMS_addSprite(48, 32, 16);

	// Turtle 6
	SMS_addSprite(32, 48, 0);
	SMS_addSprite(40, 48, 2);
	SMS_addSprite(48, 48, 4);
	SMS_addSprite(32, 64, 6);
	SMS_addSprite(40, 64, 8);
	SMS_addSprite(48, 64, 10);
	SMS_addSprite(32, 80, 12);
	SMS_addSprite(40, 80, 14);
	SMS_addSprite(48, 80, 16);

	// Turtle 7
	SMS_addSprite(32, 96, 0);
	SMS_addSprite(40, 96, 2);
	SMS_addSprite(48, 96, 4);
	SMS_addSprite(32, 112, 6);
	SMS_addSprite(40, 112, 8);
	SMS_addSprite(48, 112, 10);
	SMS_addSprite(32, 128, 12);
	SMS_addSprite(40, 128, 14);
	SMS_addSprite(48, 128, 16);
}

void AddAdjoiningSprites() {
	UNSAFE_SMS_copySpritestoSAT();
	SMS_initSprites();
	// Turtle 1
	SMS_addThreeAdjoiningSprites(0, 0, 0);
	SMS_addThreeAdjoiningSprites(0, 16, 6);
	SMS_addThreeAdjoiningSprites(0, 32, 12);

	// Turtle 2
	SMS_addThreeAdjoiningSprites(0, 48, 0);
	SMS_addThreeAdjoiningSprites(0, 64, 6);
	SMS_addThreeAdjoiningSprites(0, 80, 12);

	// Turtle 3
	SMS_addThreeAdjoiningSprites(0, 96, 0);
	SMS_addThreeAdjoiningSprites(0, 112, 6);
	SMS_addThreeAdjoiningSprites(0, 128, 12);

	// Turtle 4
	SMS_addThreeAdjoiningSprites(0, 144, 0);
	SMS_addThreeAdjoiningSprites(0, 160, 6);
	SMS_addThreeAdjoiningSprites(0, 176, 12);

	// Turtle 5
	SMS_addThreeAdjoiningSprites(32, 0, 0);
	SMS_addThreeAdjoiningSprites(32, 16, 6);
	SMS_addThreeAdjoiningSprites(32, 32, 12);

	// Turtle 6
	SMS_addThreeAdjoiningSprites(32, 48, 0);
	SMS_addThreeAdjoiningSprites(32, 64, 6);
	SMS_addThreeAdjoiningSprites(32, 80, 12);

	// Turtle 7
	SMS_addThreeAdjoiningSprites(32, 96, 0);
	SMS_addThreeAdjoiningSprites(32, 112, 6);
	SMS_addThreeAdjoiningSprites(32, 128, 12);
}

// Program entry
void main()
{
	// Initialization
	SMS_init();
	SMS_setSpriteMode (SPRITEMODE_TALL); // 8 x 16 sized sprites
	SMS_useFirstHalfTilesforSprites(false);
	SMS_displayOn();

	// Load Leo palette and tiles
	SMS_mapROMBank(blank_pal_bin_bank);
	SMS_loadBGPalette(blank_pal_bin);
	SMS_mapROMBank(blank_tiles_bin_bank);
    SMS_loadTiles(blank_tiles_bin, 0, blank_tiles_bin_size);
	SMS_mapROMBank(blank_map_bin_bank);
    SMS_loadTileMap(0, 0, blank_map_bin, blank_map_bin_size);
	SMS_mapROMBank(leo_pal_bin_bank);
	SMS_loadSpritePalette(leo_pal_bin);
	SMS_mapROMBank(leo_idle_right_tiles_bin_bank);
    SMS_loadTiles(leo_idle_right_tiles_bin, 256, leo_idle_right_tiles_bin_size);

	// Load sprites
	LoadSprites();

	// Game loop
    for (;;) {
		// Update sprite positions and tile ids
		// UpdateSprites();
		// AddSprites();
		AddAdjoiningSprites();
		SMS_waitForVBlank();
	}
}